Imports System.ComponentModel
Imports System.Drawing
Imports System.WinForms
Imports System.Drawing.Drawing2D

Public Class Form1
    Inherits System.WinForms.Form

    ' Random number generator for making random circles.
    Private m_RandomNumberGenerator As New System.Random()
    
    ' The surface we will draw on.
    Private m_DrawingSurface As System.Drawing.Graphics

    ' The pen we will draw with.
    Private m_Pen As New Pen(System.Drawing.Color.Red)
    
    Public Sub New()
        MyBase.New

        Form1 = Me

        'This call is required by the Win Form Designer.
        InitializeComponent

        ' Get the drawing surface.
        m_DrawingSurface = CreateGraphics()
    End Sub
    
    'Form overrides dispose to clean up the component list.
    Public Overrides Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub
    
#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
                Private WithEvents btnClear As System.WinForms.Button
        
                Private WithEvents btnDraw As System.WinForms.Button
                
    Dim WithEvents Form1 As System.WinForms.Form
    
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container()
            Me.btnDraw = New System.WinForms.Button()
            Me.btnClear = New System.WinForms.Button()
            
            '@design Me.TrayHeight = 0
            '@design Me.TrayLargeIcon = False
            '@design Me.TrayAutoArrange = True
            btnDraw.Location = New System.Drawing.Point(8, 8)
            btnDraw.Size = New System.Drawing.Size(48, 24)
            btnDraw.TabIndex = 0
            btnDraw.Text = "Draw"
            
            btnClear.Location = New System.Drawing.Point(64, 8)
            btnClear.Size = New System.Drawing.Size(48, 24)
            btnClear.TabIndex = 1
            btnClear.Text = "Clear"
            Me.Text = "Form1"
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            
            Me.Controls.Add(btnClear)
            Me.Controls.Add(btnDraw)
        End Sub
        
#End Region

' Clear the drawing.
Protected Sub btnClear_Click(ByVal sender As Object, ByVal e As System.EventArgs)
    m_DrawingSurface.Clear(Me.BackColor)
End Sub

' Draw a random ellipse.
Protected Sub btnDraw_Click(ByVal sender As Object, ByVal e As System.EventArgs)
    Const min_size As Integer = 20
    Dim x As Integer
    Dim y As Integer
    Dim w As Integer
    Dim h As Integer
    
    w = CType(min_size + m_RandomNumberGenerator.NextDouble() * (Me.ClientRectangle.Width * 0.5 - min_size), Integer)
    x = CType(m_RandomNumberGenerator.NextDouble() * (Me.ClientRectangle.Width - w), Integer)
    h = CType(min_size + m_RandomNumberGenerator.NextDouble() * (Me.ClientRectangle.Height * 0.5 - min_size), Integer)
    y = CType(m_RandomNumberGenerator.NextDouble() * (Me.ClientRectangle.Height - h), Integer)
    m_DrawingSurface.DrawEllipse(m_Pen, x, y, w, h)
End Sub

End Class
